Bug 128721 - Arabic RTL - position of the Next/Previous Arrows not correct
Arabic RTL - position of the Next/Previous Arrows not correct
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: redhat-artwork (Show other bugs)
rawhide
All Linux
medium Severity high
: ---
: ---
Assigned To: Alexander Larsson
FC3
:
Depends On:
Blocks: FC3Target
  Show dependency treegraph
 
Reported: 2004-07-28 12:26 EDT by Sherif Abdelgawad
Modified: 2013-08-05 23:19 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-13 12:19:28 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
test program that shows this (371 bytes, text/plain)
2004-07-30 01:56 EDT, Jeremy Katz
no flags Details

  None (edit)
Description Sherif Abdelgawad 2004-07-28 12:26:31 EDT
From Bugzilla Helper:
User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET 
CLR 1.1.4322)

Description of problem:
Pick Arabic as your Install Lang. The arrows for "Next" & Previous" / 
(Forward & Back) when the screen switch to RTL would be pointing like 
this:

------>  <-----
Forward  Back

The right direction should be :

<---  ---->
Back  Forward

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.Pick Arabic as your Lang while installing
2.Press Next

    

Actual Results:  Screen will be switched to Arabic .. Arrows will be 
pointing in wrong directions facing each others like this:

------->   <----
Forward    Back

Expected Results:  Arrows should be swapped in place to point to the 
right direction when RTL happens, and should look like:

<-----  ------>
Back    Forward

Additional info:
Comment 1 Sherif Abdelgawad 2004-07-28 17:44:31 EDT
Ops .. I got that wrong .. sorry .. it should be:

<------   ------> 
Forward   Back

Comment 2 Jeremy Katz 2004-07-30 01:55:37 EDT
Hrmmm, as far as I can tell, the right thing *should* be happening
unless I'm missing something.  Adding gtk guys to the cc list to tell
me if there's more I should have to do :)

Also, attaching trivial test program that shows gtk-go-forward as
-->

with the direction set to RTL.
Comment 3 Jeremy Katz 2004-07-30 01:56:15 EDT
Created attachment 102312 [details]
test program that shows this
Comment 4 Owen Taylor 2004-07-30 11:48:49 EDT
Try with a different theme and you'll see that the direction swaps
properly. The Bluecurve icon theme doesn't have the necessary 
multiple images for the stock icons.
Comment 5 Sherif Abdelgawad 2004-07-30 12:55:10 EDT
I am not if I am missing something here .. I am talking about 
Anaconda installation ... FC3 installation has Arabic in the first 
screen which you can choose to have the interface arabic. So what 
Themes are we talking about here? And why it is has been changed to 
art work ?
Comment 6 Owen Taylor 2004-07-30 13:00:01 EDT
The installer uses the default Red Hat theme "Bluecurve", and the
problem is coming from the icons in that theme.
Comment 7 Sherif Abdelgawad 2004-07-30 13:03:49 EDT
Ahaa .. now it makes more sense : ) 
Comment 8 Basem Narmok 2004-08-01 01:06:15 EDT
Hi all,
Sorry I was busy last days, this patch will fix the problem ... it is
a small hack that I use to fix the RTL/LTR buttons direction in
anaconda, I have another one for firstboot (I will email it to the
anaconda devel list too):

diff -Naur anaconda-10.0.1/gui.py anaconda-10.0.1-new/gui.py
--- anaconda-10.0.1/gui.py      2004-06-21 21:51:17.000000000 +0300
+++ anaconda-10.0.1-new/gui.py  2004-08-01 08:04:33.705498976 +0300
@@ -741,6 +741,21 @@
        self.updateStockButtons()
        self.loadReleaseNotes()
         self.refreshHelp(recreate = 1)
+        self.chkRtLButtons()
+
+    def chkRtLButtons(self):
+        ltrrtl = gettext.dgettext("gtk20", "default:LTR")
+        if ltrrtl == "default:RTL":
+            self.buttonBox.remove (self.nextButtonStock)
+            self.buttonBox.remove (self.prevButtonStock)
+            self.buttonBox.add (self.nextButtonStock)
+            self.buttonBox.add (self.prevButtonStock)
+        else:
+            self.buttonBox.remove (self.prevButtonStock)
+            self.buttonBox.remove (self.nextButtonStock)
+            self.buttonBox.add (self.prevButtonStock)
+            self.buttonBox.add (self.nextButtonStock)
+

     def setLtR(self):
         ltrrtl = gettext.dgettext("gtk20", "default:LTR")
@@ -1350,6 +1365,7 @@

         self.buttonBox.add (self.prevButtonStock)
         self.buttonBox.add (self.nextButtonStock)
+        self.chkRtLButtons()

        self.hbox = gtk.HBox ()
         self.hbox.set_border_width(5)
Comment 9 Basem Narmok 2004-08-01 01:29:41 EDT
Hi all,
This pach fixs the same problem in firstboot ...

diff -Naur firstboot-1.3.16/src/firstbootWindow.py
firstboot-1.3.16-new/src/firstbootWindow.py
--- firstboot-1.3.16/src/firstbootWindow.py     2004-06-30
02:09:10.000000000 +0300
+++ firstboot-1.3.16-new/src/firstbootWindow.py 2004-08-01
08:29:43.173025032 +0300
@@ -26,6 +26,7 @@

 import sys
 import gtk
+import gettext
 import gobject
 import functions
 import firstbootBackend
@@ -185,7 +186,6 @@
         label.set_property("use_underline", gtk.TRUE)
         self.backButton.connect('clicked', self.backClicked)
         self.backButton.set_sensitive(gtk.FALSE)
-        self.bb.pack_start(self.backButton)
         # Create the "go forward" button.
         self.nextButton = gtk.Button(stock='gtk-go-forward')
         label =
self.nextButton.get_children()[0].get_children()[0].get_children()[1]
@@ -194,7 +194,16 @@

         self.nextHandler = self.nextButton.connect('clicked',
self.nextClicked)

-        self.bb.pack_start(self.nextButton)
+        # LTR/RTL navigation hack
+        ltrrtl = gettext.dgettext("gtk20", "default:LTR")
+        if ltrrtl == "default:RTL":
+            self.bb.pack_start(self.nextButton)
+            self.bb.pack_start(self.backButton)
+        else:
+            self.bb.pack_start(self.backButton)
+            self.bb.pack_start(self.nextButton)
+
+
        # Add the button box to the bottom of the box which contains
the notebook.

         self.internalVBox.pack_start(self.bb, gtk.FALSE)
Comment 10 Owen Taylor 2004-08-01 13:55:42 EDT
Fixing this in the tools is wrong and will cause *incorrect*
rendering once redhat-artwork is fixed.
Comment 11 Basem Narmok 2004-08-01 14:26:54 EDT
so what about switching icons, like
use gtk-go-next icon for RTL back
use gtk-go-back icon for RTL next
what do you say?
dear Owen what will be the fix in the redhat-artwork package?
Thank you

Regards
Basem Narmok
Comment 13 Alexander Larsson 2004-09-13 12:19:28 EDT
redhat-artwork 0.99-1 has correct rtl icons.

Note You need to log in before you can comment on or make changes to this bug.